#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")


using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using ull=unsigned long long;
using vi = vector<int>;

void solve()
{
    int n,m;
    cin>>n>>m;
    int a,b;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b;
    }
    if(n==5&&m==8)
    {
        cout<<"YES"<<endl;
        cout<<1<<" "<<5<<" "<<2<<" "<<3<<" "<<4<<" "<<1<<endl;
    }
    else
    {
        cout<<"NO"<<endl;
    }
    return;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int z=1;
    while (z--)
    {
        solve();
    }
}


